glibmm 2.88.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gio::SocketAddress Class Reference
Portable Network I/O Functionality

Abstract base class representing endpoints for socket communication. More...

`#include <giomm/socketaddress.h>`

Inheritance diagram for Gio::SocketAddress:
[legend]

## Public Member Functions
| SocketAddress (SocketAddress &&src) noexcept
SocketAddress & | operator= (SocketAddress &&src) noexcept
| ~SocketAddress () noexcept override
GSocketAddress * | gobj ()
| Provides access to the underlying C GObject.
const GSocketAddress * | gobj () const
| Provides access to the underlying C GObject.
GSocketAddress * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
SocketFamily | get_family () const
| Gets the socket family type of address.
bool | to_native (gpointer dest, gsize destlen)
| Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind().
gssize | get_native_size () const
| Gets the size of address's native struct sockaddr.
Glib::PropertyProxy_ReadOnly< SocketFamily > | property_family () const
| The family of the socket address.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable &&src) noexcept
SocketConnectable & | operator= (SocketConnectable &&src) noexcept
| ~SocketConnectable () noexcept override
GSocketConnectable * | gobj ()
| Provides access to the underlying C GObject.
const GSocketConnectable * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable.
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy.
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return a ProxyAddress for each of its addresses that you must connect to via a proxy.
Glib::ustring | to_string () const
| Format a SocketConnectable as a string.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Called by constructors of derived classes.
| Interface (GObject *castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SocketAddress > | create (gpointer native, gsize len)
| Creates a SocketAddress subclass corresponding to the native struct sockaddr native.
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::SocketAddress > | wrap (GSocketAddress *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Related Symbols inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it.

## Detailed Description

Abstract base class representing endpoints for socket communication.

Since glibmm 2.24:

## Constructor & Destructor Documentation

## ◆ SocketAddress()

Gio::SocketAddress::SocketAddress | ( | SocketAddress && | src | ) |
| noexcept

## ◆ ~SocketAddress()

Gio::SocketAddress::~SocketAddress | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< SocketAddress > Gio::SocketAddress::create | ( | gpointer | native,
|  | gsize | len
| ) |  |
| static

Creates a SocketAddress subclass corresponding to the native struct sockaddr native.

Since glibmm 2.22:

Parameters

  native | A pointer to a struct sockaddr.
  len | The size of the memory location pointed to by native.

Returns
  A new SocketAddress if native could successfully be converted, otherwise `nullptr`.

## ◆ get_family()

SocketFamily Gio::SocketAddress::get_family | ( |  | ) | const

Gets the socket family type of address.

Since glibmm 2.22:

Returns
  The socket family type of address.

## ◆ get_native_size()

gssize Gio::SocketAddress::get_native_size | ( |  | ) | const

Gets the size of address's native struct sockaddr.

You can use this to allocate memory to pass to g_socket_address_to_native().

Since glibmm 2.22:

Returns
  The size of the native struct sockaddr that address represents, or `-1` if address is not valid.

## ◆ get_type()

static GType Gio::SocketAddress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GSocketAddress * Gio::SocketAddress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GSocketAddress * Gio::SocketAddress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GSocketAddress * Gio::SocketAddress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SocketAddress & Gio::SocketAddress::operator= | ( | SocketAddress && | src | ) |
| noexcept

## ◆ property_family()

Glib::PropertyProxy_ReadOnly< SocketFamily > Gio::SocketAddress::property_family | ( |  | ) | const

The family of the socket address.

Since glibmm 2.22:

Default value: Gio::SocketFamily::INVALID

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ to_native()

bool Gio::SocketAddress::to_native | ( | gpointer | dest,
|  | gsize | destlen
| ) |  |

Converts a SocketAddress to a native struct sockaddr, which can be passed to low-level functions like connect() or bind().

If not enough space is available, a Gio::Error::NO_SPACE error is returned. If the address type is not known on the system then a Gio::Error::NOT_SUPPORTED error is returned.

Since glibmm 2.22:

Parameters

  dest | A pointer to a memory location that will contain the native struct sockaddr.
  destlen | The size of dest. Must be at least as large as g_socket_address_get_native_size().

Returns
  `true` if dest was filled in, `false` on error.

Exceptions

  Glib::Error |

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::SocketAddress > wrap | ( | GSocketAddress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.